/*
 **	\file a.h
 **	\date  2006-04-20
 **	\author grymse@alhem.net
**/
/*
Copyright (C) 2006  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
//#define DEBUG
//#define DEBUGEXPR
//#define YYDEBUG         1


typedef struct linestruct
{
	struct linestruct *next;
	int line;
	int parent;
	int child;
	char *the_str;
} LINE;

typedef struct variablestruct
{
	struct variablestruct *next;
	char name[40];
	int ivalue;
	double value;
	double fnvalue;
	char svalue[1024];
} VARIABLE;

typedef struct varliststruct
{
	VARIABLE *var[99];
	int qty;
} VARLIST;

typedef struct
{
	double values[99];
	int qty;
} EXPRLIST;

typedef struct
{
	long values[99];
	int qty;
} INTLIST;

typedef struct forloopstruct
{
	struct forloopstruct *next;
	LINE *ln;
	VARIABLE *var;
	double tolimit;
	double step;
	LINE *reline;
} NEXT;

typedef struct substruct
{
	struct substruct *next;
	LINE *returnline;
} SUB;

typedef struct openstruct
{
	struct openstruct *next;
	char name[40];
	FILE *fil;
	struct stat file_stat;
	int option_s;
	int option_d;
	int option_l;
	int option_r;
} OPEN;

typedef struct datastruct
{
	struct datastruct *next;
	int line;
	char *data;
} DATA;

typedef struct funcstruct
{
	struct funcstruct *next;
	char name[40];
	VARIABLE *placeholder;
	LINE *fnline;
} FUNC;

extern	VARIABLE *variablebase;
extern	VARIABLE *placeholder;
extern	LINE *linebase;
extern	LINE *current_line;
extern	LINE *next_line;
extern	NEXT *nextbase;
extern	SUB *subbase;
extern	OPEN *openbase;
extern	DATA *database;
extern	FUNC *funcbase;
extern	char the_str[1024];
extern	int the_ptr;
extern	short running;
extern	char run_program[40];

int yylex();
void yyerror(char *);
void addlist(void *,void *);
VARIABLE *reg_variable(char *name,EXPRLIST *);
void text_output(char *);
void file_input(char *,int);
void file_init(void);
void removelist(void *,void *);
void read_data(VARLIST *);
